<template>
    <div class="content-header" v-loading.fullscreen.lock="fullscreenLoading">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1 class="m-0">Tipos</h1>
                </div><!-- /.col -->
                <div class="col-sm-6">
                    <button class="btn btn-primary" style="float: right" @click.prevent="clearFields();active_crear = true;">
                        Agregar
                    </button>
                </div>
            </div><!-- /.row -->
        </div><!-- /.container-fluid -->

        <div class="card">
            <template>
                <div class="center">
                    <vs-table>
                        <template #header>
                            <vs-input v-model="search" border placeholder="Buscar" />
                        </template>
                        <template #thead>
                            <vs-tr>                                
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'TIP_NOMBRE')">
                                    Nombre
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'TIP_PREFIJO')">
                                    Prefijo
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'TIP_ID')">
                                    ID
                                </vs-th>
                                <vs-th>-</vs-th>
                            </vs-tr>
                        </template>
                        <template #tbody>
                            <vs-tr :key="i" v-for="(tr, i) in $vs.getPage($vs.getSearch(listas, search), page, max)" :data="tr">
                                <vs-td>
                                    {{ tr.TIP_NOMBRE }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.TIP_PREFIJO }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.TIP_ID }}
                                </vs-td>
                                <vs-td>
                                    <div class="btn-group">
                                        <button type="button" class="btn btn-primary" @click.prevent="showModalUpdate(tr)">
                                            <i class="fa fa-edit"></i>
                                        </button>
                                        <button type="button" class="btn btn-danger" @click.prevent="eliminarRegistro(tr)">
                                            <i class="fa fa-trash"></i>
                                        </button>
                                    </div>
                                </vs-td>
                            </vs-tr>
                        </template>
                        <template #footer>
                            <vs-pagination v-model="page" :length="$vs.getLength($vs.getSearch(listas, search), max)"/>
                        </template>
                    </vs-table>
                </div>
            </template>
        </div> 

        <vs-dialog overflow-hidden v-model="active_crear">
            <template #header>
                <h4 class="not-margin text-primary">
                    Crear Tipo
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Prefijo" v-model="prefijo" />
                <br/>
                <vs-input label-placeholder="Nombre" v-model="nombre" />
            </div>
            <template #footer>
                <div class="footer-dialog">
                    <vs-button block @click.prevent="submitSave()">
                        Guardar
                    </vs-button>
                </div>
            </template>
        </vs-dialog>

        <vs-dialog overflow-hidden v-model="active_update">
            <template #header>
                <h4 class="not-margin text-primary">
                    Editar Tipo
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Prefijo" v-model="prefijo" />
                <br/>
                <vs-input label-placeholder="Nombre" v-model="nombre" />              
            </div>
            <template #footer>
                <div class="footer-dialog">
                    <vs-button block @click.prevent="submitUpdate()">
                        Actualizar
                    </vs-button>
                </div>
            </template>
        </vs-dialog>
    </div>
</template>

<script>
export default {
    data: () => ({
        fullscreenLoading: false,
        page: 1,
        max: 5,
        search: '',
        listas: [],
        active_crear: false,
        active_update: false,
        idf: 0,
        nombre: '',
        prefijo: '',        
    }),
    mounted() {
        this.getLista();
    },
    methods: {
        getLista() {
            this.fullscreenLoading = true;
            axios.get('/tipos/index')
            .then(response => {
                this.listas = response.data;
                this.fullscreenLoading = false;
            });
        },
        submitSave() {
            this.fullscreenLoading = true;
            axios.post('/tipos/save', {
                nombre: this.nombre,
                prefijo: this.prefijo
            })
            .then(() => {
                this.active_crear = false;
                this.clearFields();;
                this.getLista();
            });
        },
        showModalUpdate(item) {
            this.idf = item.TIP_ID;
            this.nombre = item.TIP_NOMBRE;
            this.prefijo = item.TIP_PREFIJO;
            this.active_update = true;
        },
        submitUpdate() {
            this.fullscreenLoading = true;
            axios.post('/tipos/update', {
                id: this.idf,
                nombre: this.nombre,
                prefijo: this.prefijo,
            })
            .then(() => {
                this.active_update = false;
                this.clearFields();
                this.getLista();
            });
        },
        eliminarRegistro(item) {
            this.$swal.fire({
                title: '¿Estás seguro de eliminar el siguiente registro '+item.TIP_NOMBRE+'?',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Eliminar',
                cancelButtonText: 'Cancelar',
            }).then((result) => {
                if (result.isConfirmed) {
                    this.submitDelete(item);
                }
            });
        },
        submitDelete(item) {
            this.fullscreenLoading = true;
            axios.post('/tipos/delete', {
                id: item.TIP_ID
            })
            .then(() => {
                this.active_update = false;
                this.getLista();
            });
        },
        clearFields(){
            this.nombre = '';
            this.prefijo = '';
        }
    }
}
</script>